#ifndef _SIP_MSG__H
#define	_SIP_MSG__H

#define sip_generic_param_add(LIST,NAME,VALUE)		sip_uri_param_add(LIST,NAME,VALUE)
#define sip_uri_uparam_add(url,name,value) 			sip_uri_param_add((&(url)->params),name,value)

int sip_recv_msg_handling(char *msg, WORD len, int tcpSockIndex);
int sip_method_api_conv(char *str, BYTE *method, BYTE flag);
int sip_uri_type_api_conv(char *str, BYTE *uriType, BYTE flag);
int sip_ver_api_conv(char *str, BYTE *ver, BYTE flag);
int sip_proto_api_conv(char *str, BYTE *proto, BYTE flag);
int sip_content_type_api_conv(char *str, BYTE *contentType, BYTE flag);
int sip_content_sub_type_api_conv(char *str, BYTE *contentSubType, BYTE flag);
int sip_accept_type_api_conv(char *str, BYTE *acceptType, BYTE flag);
int sip_accept_sub_type_api_conv(char *str, BYTE *acceptSubType, BYTE flag);
int sip_accept_encoding_api_conv(char *str, BYTE *acceptEncoding, BYTE flag);
int sip_accept_language_api_conv(char *str, BYTE *acceptLanguage, BYTE flag) ;
int sip_allow_api_conv(char *str, BYTE *allowMethod, BYTE flag);
int sip_option_tag_api_conv(char *str, BYTE *option, BYTE flag);
int sip_mime_version_api_conv(char *str, BYTE *mimeVersion, BYTE flag);
int sip_date_weekday_api_conv(char *str, BYTE *weekday, BYTE flag);
int sip_date_month_api_conv(char *str, BYTE *month, BYTE flag);
int sip_date_type_api_conv(char *str, BYTE *dateType, BYTE flag);
int sip_content_disposition_api_conv(char *str, BYTE *contentDisposition, BYTE flag);
int sip_content_encoding_api_conv(char *str, BYTE *contentEncoding, BYTE flag);
int sip_content_language_api_conv(char *str, BYTE *contentLanguage, BYTE flag);
void sip_fill_msg_with_cr(SIP_MSG *sipMsg, SIP_CR_MSG *sipCrMsg);
void sip_fill_cr_msg(SIP_CR_MSG *sipCrMsg, SIP_API_STRUCT *sipApiMsg);
int sip_send_ack(SIP_API_STRUCT *ackMsg, SIP_TRANSACTION *trans);
int sip_send_100(SIP_CR_MSG *ackMsg, SIP_TRANSACTION *trans);
int sip_send_option_rsp(SIP_API_STRUCT *sipApiMsg);
BYTE sip_search_user_by_domain(SIP_URI *sipUri);
int sip_send_call_not_exit_rsp(SIP_API_STRUCT *sipApiMsg);
int sip_send_not_find_rsp(SIP_API_STRUCT *sipApiMsg);

#endif
